searchNodes=[{"doc":"Generates router and plug handlers for a proper OpenAPI Specification in YAML or JSON file.mix oas.gen.plug --file path/to/openapi.yaml mix oas.gen.plug --file path/to/openapi.yml mix oas.gen.plug --file path/to/openapi.jsonThe arguments of oas.gen.plug mix task:--file, required, the completed path to the specification file in YAML or JSON format.--router, optional, the generated router's module alias, by default it is Router (the full module name is Oasis.Gen.Router by default), for example we set --router Hello.MyRouter meanwhile there is no other special name space defined, the final router module is Oasis.Gen.Hello.MyRouter in /lib/oasis/gen/hello/my_router.ex path.--name-space, optional, the generated all modules' name space, by default it is Oasis.Gen, this argument will always override the name space from the input --file if any &quot;x-oasis-name-space&quot; field(s) defined.","ref":"Mix.Tasks.Oas.Gen.Plug.html","title":"Mix.Tasks.Oas.Gen.Plug","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Oas.Gen.Plug.html#run/1","title":"Mix.Tasks.Oas.Gen.Plug.run/1","type":"function"},{"doc":"","ref":"Oasis.CacheRawBodyReader.html","title":"Oasis.CacheRawBodyReader","type":"module"},{"doc":"","ref":"Oasis.CacheRawBodyReader.html#read_body/2","title":"Oasis.CacheRawBodyReader.read_body/2","type":"function"},{"doc":"Base on Plug.Builder, this module can be use-d into a module in order to build a plug pipeline:defmodule MyApp.HelloController do use Oasis.Controller plug(Plug.Parsers, parsers: [:urlencoded], pass: [&quot;*/*&quot;] ) def call(conn, opts) do conn = super(conn, opts) json(conn, %{&quot;body_params&quot; =&gt; conn.body_params}) end endAnd provide some common functionality for easily use, this realization comes from Phoenix.Controller","ref":"Oasis.Controller.html","title":"Oasis.Controller","type":"module"},{"doc":"Sends html response.Examplesiex&gt; html(conn, &quot;&lt;html&gt;...&lt;/html&gt;&quot;)","ref":"Oasis.Controller.html#html/2","title":"Oasis.Controller.html/2","type":"function"},{"doc":"Sends JSON response.It uses Jason to encode the input as an iodata data.Examplesiex&gt; json(conn, %{id: 1})","ref":"Oasis.Controller.html#json/2","title":"Oasis.Controller.json/2","type":"function"},{"doc":"Sends text response.Examplesiex&gt; text(conn, &quot;hello&quot;) iex&gt; text(conn, :implements_to_string)","ref":"Oasis.Controller.html#text/2","title":"Oasis.Controller.text/2","type":"function"},{"doc":"Base on Plug.Router to add a pre-parser to convert and validate the path param(s) in the final generated HTTP verb match functions.The generated router module uses Oasis.Router to instead of Plug.Router, in fact, they don't make a huge difference, except that specify parameters which will then be available and types coverted in the function body:get(&quot;/hello/:id&quot;, private: %{ path_schema: %{ &quot;id&quot; =&gt; %{ &quot;schema&quot; =&gt; %ExJsonSchema.Schema.Root{ schema: %{&quot;type&quot; =&gt; &quot;integer&quot;} } } } }) do # Notice that the `:id` variable is an integer send_resp(conn, 200, &quot;hello \#{id}&quot;) endThe :id parameter will also be available and coverted as an integer in the function body as conn.params[&quot;id&quot;] and conn.path_params[&quot;id&quot;].","ref":"Oasis.Router.html","title":"Oasis.Router","type":"module"},{"doc":"A plug to convert types and validate the HTTP request parameters by the schemas of the OpenAPI definition.The schema options can be found in the generated pre- plug handler file, the full list::query_schema:header_schema:cookie_schema:body_schemaAll of these options are fully map and generated from the corresponding definition of the OpenAPI Specification.When the query parameters are verified by the validation of :query_schema, the coverted types of query parameters are reserved in :query_params and :params field of the Plug.Conn.When the header parameters are verified by the validation of :header_schema, the converted types of header parameters are reserved in :req_headers field of the Plug.Conn.When the cookie parameters are verified by the validation of :cookie_schema, the coverted types of cookie parameters are reserved in :req_cookies field of the Plug.Conn.When the request body is verified by the validation of :body_schema, the coverted types of request body are reserved in :body_params and :params field of the Plug.Conn.","ref":"Oasis.Plug.RequestValidator.html","title":"Oasis.Plug.RequestValidator","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Oasis.Plug.RequestValidator.html#call/2","title":"Oasis.Plug.RequestValidator.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Oasis.Plug.RequestValidator.html#init/1","title":"Oasis.Plug.RequestValidator.init/1","type":"function"},{"doc":"Error raised when use an invalid file path to generate corresponding modules","ref":"Oasis.FileNotFoundError.html","title":"Oasis.FileNotFoundError","type":"exception"},{"doc":"Error raised when use some invalid OpenAPI specification to generate corresponding modules","ref":"Oasis.InvalidSpecError.html","title":"Oasis.InvalidSpecError","type":"exception"},{"doc":"Oasis","ref":"readme.html","title":"Oasis","type":"extras"},{"doc":"BackgroundThe OpenAPI Specification (OAS) defines a standard, programming language-agnostic interface description for REST APIs, which allows both humans and computers to discover and understand the capabilities of a service without requiring access to source code, additional documentation, or inspection of network traffic. When properly defined via OpenAPI, a consumer can understand and interact with the remote service with a minimal amount of implementation logic. Similar to what interface descriptions have done for lower-level programming, the OpenAPI Specification removes guesswork in calling a service.Oasis is:Base on Plug's implements, according to the OpenAPI Specification to generate server's router and the all well defined HTTP request handler(s), since the OAS defines a detailed collection of data types by JSON Schema Specification, Oasis leverages this and focuses on the types conversion and validation to the parameters of the HTTP request.Maintain a standard REST APIs document(in YAML or JSON) via OpenAPI is in a high priorityGenerate the maintainable router and HTTP request handlers code by the defined documentIn general, we do not need to manually write OpenAPI definitions in ElixirSimplify the REST APIs to convert types and validate the parameters of the HTTP requestMore reference and communication to your REST APIs","ref":"readme.html#introduction","title":"Oasis - Introduction","type":"extras"},{"doc":"Add oasis as a dependency to your mix.exsdef deps do [ {:oasis, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"Oasis - Installation","type":"extras"},{"doc":"Oasis does not cover the full OpenAPI specification, so far the implements contain:Components ObjectPaths ObjectPath Item ObjectOperation ObjectParameter ObjectRequest Body ObjectMedia Type ObjectHeader ObjectReference ObjectSchema Object","ref":"readme.html#implements-to-oas","title":"Oasis - Implements to OAS","type":"extras"},{"doc":"Oasis be with the following specification extensions to accommodate the use cases:&quot;x-oasis-name-space&quot;, optional, use this field to define the generated Elixir module's name space in Operation Object or Paths Object, defaults to Oasis.Gen.&quot;x-oasis-router&quot;, optional, use this field to define the generated Elixir router module's alias in Paths Object, defaults to Router.","ref":"readme.html#oas-specification-extensions","title":"Oasis - OAS Specification Extensions","type":"extras"},{"doc":"Prepare YAML or JSON specificationFirst, write your API document refer the OpenAPI Specification(see reference for details), we build Oasis with the version 3.1.0 of the OAS, as usual, the common use case should be covered for the version 3.0.* of the OAS.Here is a minimum specification for an example in YAML, we save it as &quot;petstore-mini.yaml&quot; in this tutorial.openapi: &quot;3.1.0&quot; info: title: Petstore Mini paths: /pets: get: parameters: - name: tags in: query required: false schema: type: array items: type: string - name: limit in: query requried: false schema: type: integer format: int32 response: '200': content: application/json: schema: type: array items: $ref: '#/components/schemas/Pet' post: operationId: addPet requestBody: required: true content: application/json: schema: $ref: '#/components/schemas/NewPet' response: '200': content: application/json: schema: $ref: '#/components/schemas/Pet' /pets/{id}: get: operationId: find pet by id parameters: - name: id in: path required: true schema: type: integer format: int64 response: '200': content: application/json: schema: $ref: '#/components/schemas/Pet' components: schemas: Pet: allOf: - $ref: '#/components/schemas/NewPet' - type: object required: - id properties: id: type: integer format: int64 NewPet: type: object required: - name properties: name: type: string tag: type: stringRun mix taskAnd then we run the following mix task to generate the corresponding files:mix oas.gen.plug --file path/to/petstore-mini.yamlWe will see these output:Generates Router and Plug modules from OAS * creating lib/oasis/gen/router.ex * creating lib/oasis/gen/pre_find_pet_by_id.ex * creating lib/oasis/gen/find_pet_by_id.ex * creating lib/oasis/gen/pre_add_pet.ex * creating lib/oasis/gen/add_pet.ex * creating lib/oasis/gen/pre_get_pets.ex * creating lib/oasis/gen/get_pets.exThe arguments of oas.gen.plug mix task:--file, required, the completed path to the specification file in YAML or JSON format.--router, optional, the generated router's module alias, by default it is Router (the full module name is Oasis.Gen.Router by default), for example we set --router Hello.MyRouter meanwhile there is no other special name space defined, the final router module is Oasis.Gen.Hello.MyRouter in /lib/oasis/gen/hello/my_router.ex path.--name-space, optional, the generated all modules' name space, by default it is Oasis.Gen, this argument will always override the name space from the input --file if any &quot;x-oasis-name-space&quot; field(s) defined.Special instructionsName Plug's handlerRefer the OAS, the operationId field of Operation Object is not required, but it should be unique among all operations described in the API if operationId field exists.When use this field, Oasis will use it to construct the generated module alias and the file name of &quot;.ex&quot; file, e.g. see the above find_pet_by_id.ex file with Oasis.Gen.FindPetById module name.When not use this filed, Oasis will combine the HTTP verb with the URL to generate the module alias and the file name of &quot;.ex&quot; file, e.g. see the above get_pets.ex file with Oasis.Gen.GetPets module name.Generated code to folderThe generated codes are always put in the lib directory of your application root path, because they need to be integrated into your application in runtime.Custom name space of generated modulesBy default, the name space of the generated module is Oasis.Gen and its folder path is lib/oasis/gen, but we can custom it use these ways:As a final global definition when run oas.gen.plug mix task, input --name-space argument to set this, this argument always overrides all name space even we have some sections of document have special definition (via &quot;x-oasis-name-space&quot;), for example: mix oas.gen.plug --file path/to/petstore-mini.yaml --name-space My.Petstore Generates Router and Plug modules from OAS * creating lib/my/petstore/router.ex * creating lib/my/petstore/pre_find_pet_by_id.ex * creating lib/my/petstore/find_pet_by_id.ex * creating lib/my/petstore/pre_add_pet.ex * creating lib/my/petstore/add_pet.ex * creating lib/my/petstore/pre_get_pets.ex * creating lib/my/petstore/get_pets.ex Now, we can see the generation folder path is lib/my/petstore, let's open the get_pets.ex file, the module name changed from Oasis.Gen.GetPets to My.Petstore.GetPets.Use &quot;x-oasis-name-space&quot; in the OAS's Operation Object, for example, add this newline x-oasis-name-space: Common.Api as below: paths: /pets: get: x-oasis-name-space: Common.Api parameters: - name: tags ... post: ... /pets/{id}: ... Run again, please note this time no --name-space argument. mix oas.gen.plug --file path/to/petstore-mini.yaml Generates Router and Plug modules from OAS * creating lib/oasis/gen/router.ex * creating lib/oasis/gen/pre_find_pet_by_id.ex * creating lib/oasis/gen/find_pet_by_id.ex * creating lib/oasis/gen/pre_add_pet.ex * creating lib/oasis/gen/add_pet.ex * creating lib/common/api/pre_get_pets.ex * creating lib/common/api/get_pets.ex We can see pre_get_pets.ex and get_pets.ex files are moved into the expected path, and their module names are Common.Api.GetPets and Common.Api.PreGetPets, other operations do not define any &quot;x-oasis-name-space&quot; field, so they still use the default one Oasis.Gen.Use &quot;x-oasis-name-space&quot; in the OAS's Paths Object, this use case as a global setting and can archive it in the document under the file version management, for example, add this newline x-oasis-name-space: Common.Api as below: paths: x-oasis-name-space: Common.Api /pets: get: parameters: - name: tags ... post: ... /pets/{id}: ... Run again, please note this time no --name-space argument, and the GET operation of the &quot;/pets&quot; path is no &quot;x-oasis-name-space&quot; either. mix oas.gen.plug --file path/to/petstore-mini.yaml Generates Router and Plug modules from OAS * creating lib/common/api/router.ex * creating lib/common/api/pre_find_pet_by_id.ex * creating lib/common/api/find_pet_by_id.ex * creating lib/common/api/pre_add_pet.ex * creating lib/common/api/add_pet.ex * creating lib/common/api/pre_get_pets.ex * creating lib/common/api/get_pets.exWe can see all generated files are moved into the expected path, and all modules' name start with Common.Api.Summarize about the name space of generated module:The optional --name-space argument to the mix oas.gen.plug command line is in the highest priority to set the name space;We can use &quot;x-oasis-name-space&quot; extension field of the OAS's Paths Object as a global naming if we want to save and maintain it in the document, but this case may be overridden by #1.We also can set &quot;x-oasis-name-space&quot; extension field in each Operation Object in the document, but this case may be overridden by #1 or #2.HTTP request handler files in pairsThe generated HTTP request handler files are named in pairs, one is pre_operation.ex, and another is operation.ex, the name beginning with pre_ file is in charge of converting and validating the parameters of each HTTP request definition, the content of this file will be updated according to the section of the document changes or Oasis upgrade in the future, so we CAN NOT write any business logic in this file; another file is only created in the first time of generation as long as this file does not exist, this is a common Plug module which is after the defined preprocessor by Plug's pipeline, we need to fill in business logic in here.mix oas.gen.plug --file path/to/petstore-mini.yaml Generates Router and Plug modules from OAS * creating lib/oasis/gen/router.ex * creating lib/oasis/gen/pre_find_pet_by_id.ex * creating lib/oasis/gen/find_pet_by_id.ex * creating lib/oasis/gen/pre_add_pet.ex * creating lib/oasis/gen/add_pet.ex * creating lib/oasis/gen/pre_get_pets.ex * creating lib/oasis/gen/get_pets.exIntegrationAfter the above generation, let's integrate it, assume the generated router is Oasis.Gen.Router, we can use it in the Plug's adapter like this:Plug.Adapters.Cowboy.child_spec( scheme: :http, plug: Oasis.Gen.Router, options: [ port: port ] )Or we can plug this router into the existence router module like this:defmodule MyExistenceRouter do use Plug.Router plug(Oasis.Gen.Router) plug(:match) plug(:dispatch) # other endPlease note that the added line of plug(Oasis.Gen.Router) is before the line of plug(:match).","ref":"readme.html#how-to-use","title":"Oasis - How to use","type":"extras"},{"doc":"The Specification contains XML object is not supported so far.May add mix task to generate Phoenix's style code.Make document more clear.There are still some details maybe not implement(or bug) from the OAS, please create an issue or a PR for tracking, thanks in advanced :)","ref":"readme.html#todo","title":"Oasis - Todo","type":"extras"},{"doc":"The official OpenAPI Specification v3: Github | Official Web SiteJSON Schema Reference","ref":"readme.html#reference","title":"Oasis - Reference","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fix unexpected :body_schema in generated pre_* module","ref":"changelog.html#v0-2-1-2021-03-24","title":"Changelog - v0.2.1 (2021-03-24)","type":"extras"},{"doc":"Use Oasis.Controller","ref":"changelog.html#v0-2-0-2021-03-23","title":"Changelog - v0.2.0 (2021-03-23)","type":"extras"},{"doc":"Implement some parts of OpenAPI definition *Object in parseImplement a basic router and plugs pipeline processAdd a mix task mix task oas.gen.plug to generate code100% test coverage","ref":"changelog.html#v0-1-0-2021-03-17","title":"Changelog - v0.1.0 (2021-03-17)","type":"extras"}]